;==========================================================================
    include \masm32\include\masm32rt.inc
    .686
    ;include \masm32\macros\timers.asm
    include counter2.asm
;==========================================================================

    ; -------------------------------------------------------
    ; This is an assembly-time random number generator based
    ; on code by George Marsaglia:
    ;   #define znew  ((z=36969*(z&65535)+(z>>16))<<16)
    ;   #define wnew  ((w=18000*(w&65535)+(w>>16))&65535)
    ;   #define MWC   (znew+wnew)
    ; -------------------------------------------------------

    @znew_seed@ = 362436069
    @wnew_seed@ = 521288629

    @rnd MACRO base:REQ
      LOCAL znew, wnew

      @znew_seed@ = 36969 * (@znew_seed@ AND 65535) + (@znew_seed@ SHR 16)
      znew = @znew_seed@ SHL 16

      @wnew_seed@ = 18000 * (@wnew_seed@ AND 65535) + (@wnew_seed@ SHR 16)
      wnew = @wnew_seed@ AND 65535

      EXITM <(znew + wnew) MOD base>
    ENDM

;==========================================================================
    .data
    .code
;==========================================================================
start:
;==========================================================================
    invoke GetProcessHeap
    invoke HeapAlloc, eax, HEAP_ZERO_MEMORY, 12000000
    mov esi, eax
    .if esi == 0
      print "HeapAlloc failed",13,10
    .endif

    invoke Sleep, 4000

    repeat 100
      ctr_begin 1, HIGH_PRIORITY_CLASS
        repeat 5
          mov eax, [esi+@rnd(12000000/4)*4]
        endm
      ctr_end
      print str$(eax),13,10
    endm
    print chr$(13,10)
    invoke Sleep, 2000

    invoke GetProcessHeap
    invoke HeapFree, eax, 0, esi

    invoke GetCurrentProcess
    invoke SetProcessWorkingSetSize, eax, 12000000, 12000000
    .if eax == 0
      print "SetProcessWorkingSetSize failed",13,10
    .endif

    invoke VirtualAlloc, NULL, 12000000, MEM_COMMIT, PAGE_READWRITE
    mov esi, eax
    .if esi == 0
      print "VirtualAlloc failed",13,10
    .endif

    repeat 100
      ctr_begin 1, HIGH_PRIORITY_CLASS
        repeat 5
          mov eax, [esi+@rnd(12000000/4)*4]
        endm
      ctr_end
      print str$(eax),13,10
    endm

    invoke VirtualFree, esi, 0, MEM_RELEASE

    inkey "Press any key to exit..."
    exit
;==========================================================================
end start
